//
//Chameleon USB FX2 API Ver1.00 By OPTIMIZE
//
#pragma once
#include <Windows.h>
#include "dbt.h"
#include "cyapi.h"
#include "types.h"

#define CUSB_DEBUG   0

struct _cusb2_tcb
{
	HANDLE th;
	CCyUSBEndPoint *ep;
	u8	epaddr;
	LONG xfer;
	u32 ques;
	bool (*cb_func)(u8 *, u32);
	bool looping;
	u32 nsuccess;
	u32 nfailure;
};

typedef struct _cusb2_tcb cusb2_tcb;

class cusb2
{
public:
	CCyUSBDevice *USBDevice;
	cusb2();
	~cusb2();

	bool fwload(u64 *device_dna, u8 *fw);
	CCyUSBEndPoint* get_endpoint(u8 addr);
	bool xfer(CCyUSBEndPoint *ep, PUCHAR buf, LONG &len);
	cusb2_tcb *start_thread(u8 epaddr, u32 xfer, s32 ques, bool (*cb_func)(u8 *, u32));
	void delete_thread(cusb2_tcb *tcb);
};


