
public		_jtag_trx
public		_jtag_tx
public		_jtag_tx_fix_tms
public		_jtag_wait_us
public		_jtag_tck100x
;
;-------------------- SFR ---------------------
IOA                 DATA 080H
  ;  IOA  
  PA0               BIT 080H+0H
  TDI               BIT 080H+0H
  PA1               BIT 080H+1H
  TMS               BIT 080H+1H
  PA2               BIT 080H+2H
  PA3               BIT 080H+3H
  TDO               BIT 080H+3H

  PA4               BIT 080H+4H
  PA5               BIT 080H+5H
  PA6               BIT 080H+6H
  PA7               BIT 080H+7H
  TCK               BIT 080H+7H

DPL1                DATA 084H
DPH1                DATA 085H
DPS                 DATA 086H

EXTAUTODAT1         XDATA 0xE67B  ; Autoptr1 MOVX access
EXTAUTODAT2         XDATA 0xE67C  ; Autoptr2 MOVX access

;TMP                 DATA 020H

;------------------- prgoram area -------------------
;
JTAG	SEGMENT	CODE
;
		rseg JTAG		;; locate the descriptor table in on-par;
;
;void jtag_wait_us(u8 us)
;
;	r7:us
;
_jtag_wait_us:
wait_1:
	mov	r5, #2
wait_0:
	djnz	r5, wait_0
	djnz	r7, wait_1
	ret

;
;void jtag_tck(u8 us)
;
;	r7:us
;
_jtag_tck100x:
_wait_1:
	mov	r5, #100
_wait_0:
	clr	TCK
	nop
	setb	TCK
	djnz	r5, _wait_0
	djnz	r7, _wait_1
	ret

;
;void jtag_trx(u8 n)
;
;	r7:n
;
_jtag_trx:
	inc	DPS
	mov	DPTR, #EXTAUTODAT2
	inc	DPS
	mov	DPTR, #EXTAUTODAT1
_loop:
	movx	A, @DPTR	;TMS
	mov	r0, A
	movx	A, @DPTR	;TDI
	mov	r1, A
	mov	r2, #0
	
	mov	r3, #8
	
_loopin:
;;;;;;;;;;;;;;;;;;;;;;;;;;;bit0-7
	clr	TCK
	
	mov	C, TDO
	mov	A, r2
	rrc	A
	mov	r2, A
	
	mov	A, r0
	rrc	A
	mov	TMS, C
	mov	r0, A
	
	mov	A, r1
	rrc	A
	mov	TDI, C
	mov	r1, A

	setb	TCK
	
	djnz	r3, _loopin

	mov	A, r2
	inc	DPS
	movx	@DPTR, A
	inc	DPS
	djnz	r7, _loop
	mov	r7, A
	ret

;

;
;void jtag_tx8(u8 n)
;
;	r7:n
;
_jtag_tx:
	mov	DPTR, #EXTAUTODAT1
loop:
	movx	A, @DPTR	;TMS
	mov	r0, A
	movx	A, @DPTR	;TDI
	mov	r1, A

;;;;;;;;;;;;;;;;;;;;;;;;;;;bit0
	clr	TCK
	mov	A, r0
	rrc	A
	mov	TMS, C
	mov	r0, A

	mov	A, r1
	rrc	A
	mov	TDI, C
	setb	TCK
	mov	r1, A

;;;;;;;;;;;;;;;;;;;;;;;;;;;bit1
	clr	TCK
	mov	A, r0
	rrc	A
	mov	TMS, C
	mov	r0, A

	mov	A, r1
	rrc	A
	mov	TDI, C
	setb	TCK
	mov	r1, A

;;;;;;;;;;;;;;;;;;;;;;;;;;;bit2
	clr	TCK
	mov	A, r0
	rrc	A
	mov	TMS, C
	mov	r0, A

	mov	A, r1
	rrc	A
	mov	TDI, C
	setb	TCK
	mov	r1, A

;;;;;;;;;;;;;;;;;;;;;;;;;;;bit3
	clr	TCK
	mov	A, r0
	rrc	A
	mov	TMS, C
	mov	r0, A

	mov	A, r1
	rrc	A
	mov	TDI, C
	setb	TCK
	mov	r1, A

;;;;;;;;;;;;;;;;;;;;;;;;;;;bit4
	clr	TCK
	mov	A, r0
	rrc	A
	mov	TMS, C
	mov	r0, A

	mov	A, r1
	rrc	A
	mov	TDI, C
	setb	TCK
	mov	r1, A

;;;;;;;;;;;;;;;;;;;;;;;;;;;bit5
	clr	TCK
	mov	A, r0
	rrc	A
	mov	TMS, C
	mov	r0, A

	mov	A, r1
	rrc	A
	mov	TDI, C
	setb	TCK
	mov	r1, A

;;;;;;;;;;;;;;;;;;;;;;;;;;;bit6
	clr	TCK
	mov	A, r0
	rrc	A
	mov	TMS, C
	mov	r0, A

	mov	A, r1
	rrc	A
	mov	TDI, C
	setb	TCK
	mov	r1, A

;;;;;;;;;;;;;;;;;;;;;;;;;;;bit7
	clr	TCK
	mov	A, r0
	rrc	A
	mov	TMS, C
	mov	r0, A

	mov	A, r1
	rrc	A
	mov	TDI, C
	setb	TCK
	mov	r1, A


	djnz	r7, loop
	ret
;
;
;void jtag_tx_fix_tms(u8 n)
;
;	r7:n
;
_jtag_tx_fix_tms:
	mov	DPTR, #EXTAUTODAT1
loop2:
	movx	A, @DPTR	;TDI

;;;;;;;;;;;;;;;;;;;;;;;;;;;bit0
	clr	TCK
	rlc	A
	mov	TDI, C
	setb	TCK

;;;;;;;;;;;;;;;;;;;;;;;;;;;bit1
	clr	TCK
	rlc	A
	mov	TDI, C
	setb	TCK

;;;;;;;;;;;;;;;;;;;;;;;;;;;bit2
	clr	TCK
	rlc	A
	mov	TDI, C
	setb	TCK

;;;;;;;;;;;;;;;;;;;;;;;;;;;bit3
	clr	TCK
	rlc	A
	mov	TDI, C
	setb	TCK

;;;;;;;;;;;;;;;;;;;;;;;;;;;bit4
	clr	TCK
	rlc	A
	mov	TDI, C
	setb	TCK

;;;;;;;;;;;;;;;;;;;;;;;;;;;bit5
	clr	TCK
	rlc	A
	mov	TDI, C
	setb	TCK

;;;;;;;;;;;;;;;;;;;;;;;;;;;bit6
	clr	TCK
	rlc	A
	mov	TDI, C
	setb	TCK

;;;;;;;;;;;;;;;;;;;;;;;;;;;bit7
	clr	TCK
	rlc	A
	mov	TDI, C
	setb	TCK


	djnz	r7, loop2
	ret
;
	end
